## libreswan 5.2

=== Makefile ===
# Libreswan top level Makefile
#
# Copyright (C) 1998-2002  Henry Spencer.
# Copyright (C) 2003-2004  Xelerance Corporation
# Copyright (C) 2017, Richard Guy Briggs <rgb@tricolour.ca>
# Copyright (C) 2015-2018  Andrew Cagney
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#

ifndef top_srcdir
include mk/dirs.mk
endif

LIBRESWANSRCDIR?=$(shell pwd)

include $(top_srcdir)/mk/config.mk

MAIN_RPMBUILD_SOURCES  = $(shell rpm --eval %{_sourcedir})
MAIN_RPMBUILD_SPEC  = $(shell rpm --eval %{_specdir})
MAIN_RPM_VERSION = $(shell make showversion | sed "s/-.*//")
MAIN_RPM_PREVER = $(shell make showversion | sed -e  "s/^.[^-]*-\([^-]*\)-\(.*\)/rc\1_\2/" -e "s/-/_/g" -e "s/\//_/g")
MAIN_RPM_PREFIX  = libreswan-$(MAIN_RPM_VERSION)$(MAIN_RPM_PREVER)
MAIN_RPM_RHEL_PKG = $(shell rpm -qf /etc/redhat-release)
MAIN_RPM_RHEL_VERSION = $(shell echo $(MAIN_RPM_RHEL_PKG) | sed "s/.*-release-\(.\).*/\1/")
MAIN_RPM_SPECFILE = $(shell if [ -f /etc/fedora-release ]; then echo packaging/fedora/libreswan.spec; elif [ -n "$(MAIN_RPM_RHEL_VERSION)" ]; then echo packaging/rhel/$(MAIN_RPM_RHEL_VERSION)/libreswan.spec; else echo "unknown distro, cannot find spec file to use in packaging directory"; fi)
RHEL_LIKE= $(shell cat /etc/os-release | grep ID_LIKE | sed -e "s/ID_LIKE=//" -e 's/"//g' -e "s/ .*//")
RHEL_MAJOR= $(shell cat /etc/os-release |grep VERSION_ID | sed -e 's/.*"\([0-9]*\)"/\1/' -e 's/VERSION_ID=//')
SRCDIR?=$(shell pwd)/

# dummy default rule
def: all

help:
	@echo
	@echo "To build and install on a recent Linux kernel:"
	@echo
	@echo "   make all && sudo make install"
	@echo
	@echo "For a minimal install (no manpages) type:"
	@echo
	@echo "   make base && sudo make install-base"
	@echo
	@echo "See the files INSTALL and README for more general information,"
	@echo
	@echo "To build debian packages: make deb"
	@echo "To build fedora/rhel/centos rpms: make rpm"
	@echo
	@false

.PHONY: def help

ERRCHECK=${MAKEUTILS}/errcheck
KVUTIL=${MAKEUTILS}/kernelversion
KVSHORTUTIL=${MAKEUTILS}/kernelversion-short

SUBDIRS?=lib programs initsystems testing configs

TAGSFILES = $(wildcard include/*.h include/*/*.h lib/lib*/*.[ch] programs/*/*.[ch] testing/check/*/*.[ch])

tags: $(TAGSFILES)
	LC_ALL=C ctags $(CTAGSFLAGS) ${TAGSFILES}

cscope:
	ls ${TAGSFILES} > cscope.files
	cscope -b

TAGS: $(TAGSFILES)
	LC_ALL=C etags $(ETAGSFLAGS) ${TAGSFILES}

.PHONY: dummy
dummy:


# Run regress stuff after the other check targets.
.PHONY: regress
check: regress
regress: local-check recursive-check
ifneq ($(strip(${REGRESSRESULTS})),)
	mkdir -p ${REGRESSRESULTS}
	-perl testing/utils/regress-summarize-results.pl ${REGRESSRESULTS}
endif
	@echo "======== End of make check target. ========"

include ${LIBRESWANSRCDIR}/mk/targets.mk

# directories visited by all recursion

# programs

ABSOBJDIR:=$(shell mkdir -p ${OBJDIR}; cd ${OBJDIR} && pwd)
OBJDIRTOP=${ABSOBJDIR}

# Recursive clean dealt with elsewhere.
.PHONY: local-clean-base
local-clean-base:
	rm -rf out.*
	rm -rf $(OBJDIR)/html

# Delete absolutely everything.
#
# Since "clean" is a recursive target and requires the existence of
# $(OBJDIR), "distclean" does not depend on it.  If it did, "make
# distclean" would have the quirky behaviour of first creating
# $(OBJDIR) only to then delete it.

.PHONY: distclean
distclean:
	: generated test keys
	: careful output mixed with repo files
	rm -rf testing/x509/*/
	rm -f testing/baseconfigs/all/etc/bind/signed/*.signed
	rm -f testing/baseconfigs/all/etc/bind/keys/*.key
	rm -f testing/baseconfigs/all/etc/bind/keys/*.private
	rm -f testing/baseconfigs/all/etc/bind/dsset/dsset-*
	: test results
	rm -rf testing/pluto/*/OUTPUT*
	rm -rf BACKUP
	: build results
	rm -f out.*
	rm -rf OBJ.* $(OBJDIR)
	rm -f tags TAGS cscope
	rm -f cscope.files

rpm:
	@if [ -d .git ]; then \
		echo "For git trees, please run: make git-rpm" ; \
	fi
	@if [ ! -d .git -a -n "$(RHEL_LIKE)" ]; then \
		rpmbuild -ba packaging/rhel/$(RHEL_MAJOR)/libreswan.spec ; \
	fi
	@if [ ! -d .git -a -f /etc/fedora-release ]; then \
		rpmbuild -ba packaging/fedora/libreswan.spec ; \
	fi

git-rpm:
	@echo building rpm for libreswan testing
	mkdir -p $(MAIN_RPMBUILD_SPEC) $(MAIN_RPMBUILD_SOURCES)
	sed  -e "s/^Version:.*/Version: $(MAIN_RPM_VERSION)/g" \
	     -e "s/^.global prever.*/%global prever $(MAIN_RPM_PREVER)/" \
	     -e "s/^Release:.*/Release: 0.$(MAIN_RPM_PREVER)/" \
		$(MAIN_RPM_SPECFILE) > $(MAIN_RPMBUILD_SPEC)/libreswan.spec
	git archive --format=tar --prefix=libreswan-$(MAIN_RPM_VERSION)$(MAIN_RPM_PREVER)/ \
		-o $(MAIN_RPMBUILD_SOURCES)/libreswan-$(MAIN_RPM_VERSION)$(MAIN_RPM_PREVER).tar HEAD
	if [ -a Makefile.inc.local ] ; then \
		tar --transform "s|^|$(MAIN_RPM_PREFIX)/|" -rf $(MAIN_RPMBUILD_SOURCES)/$(MAIN_RPM_PREFIX).tar Makefile.inc.local ; \
	fi;
	echo 'IPSECBASEVERSION=$(MAIN_RPM_VERSION)$(MAIN_RPM_PREVER)' > $(MAIN_RPMBUILD_SOURCES)/version.mk
	( pushd $(MAIN_RPMBUILD_SOURCES); tar --transform "s|^|$(MAIN_RPM_PREFIX)/mk/|" -rf $(MAIN_RPMBUILD_SOURCES)/$(MAIN_RPM_PREFIX).tar version.mk; popd)
	rm $(MAIN_RPMBUILD_SOURCES)/version.mk
	gzip -f $(MAIN_RPMBUILD_SOURCES)/$(MAIN_RPM_PREFIX).tar
	# get IKE test vectors if needed
	spectool --get-files $(MAIN_RPMBUILD_SPEC)/libreswan.spec --directory $(MAIN_RPMBUILD_SOURCES);
	rpmbuild -ba $(MAIN_RPMBUILD_SPEC)/libreswan.spec

tarpkg:
	@echo "Generating tar.gz package to install"
	@rm -rf /var/tmp/libreswan-${USER}
	@make DESTDIR=/var/tmp/libreswan-${USER} programs install
	@rm /var/tmp/libreswan-${USER}/etc/ipsec.conf
	@(cd /var/tmp/libreswan-${USER} && tar czf - . ) >libreswan-${IPSECVERSION}.tgz
	@ls -l libreswan-${IPSECVERSION}.tgz
	@rm -rf /var/tmp/libreswan-${USER}


env:
	@env | sed -e "s/'/'\\\\''/g" -e "s/\([^=]*\)=\(.*\)/\1='\2'/"

#
#  A target that does nothing intesting is sometimes interesting...
war:
	@echo "Not Love?"

showversion:
	@echo ${IPSECVERSION} | sed "s/^v//"
showdebversion:
	@$(MAKE) --silent --directory packaging/debian showdebversion
showrpmversion:
	@echo ${IPSECVERSION} |  sed "s/^v//" | sed -e "s/^v//;s/\([0-9]\{1,3\}\)\.\([0-9]\{1,3\}\)\(.*\)/\1.\2_\3/;s/-/_/g;s/__/_/g"
showrpmrelease:
	@echo ${IPSECVERSION} | sed "s/^v//" | sed "s/^[^-]*-\(.*\)/\1/"
showobjdir:
	@echo $(OBJDIR)

# these need get fixed not to use root
.PHONY: deb
deb:
	if [ -f /etc/devuan_version ]; then \
		$(MAKE) --directory packaging/devuan ; \
	else \
		$(MAKE) --directory packaging/debian ; \
	fi

release:
	packaging/utils/makerelease

local-install:

.PHONY: web web-page
web web-page:
	$(MAKE) -C testing/web web-publish

include ${LIBRESWANSRCDIR}/mk/docker-targets.mk

=== configs/Makefile ===
# Makefile for miscellaneous programs
# Copyright (C) 2002-2006  Michael Richardson	<mcr@xelerance.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

# the man page source is generated
MANPAGES += ipsec.conf.5
MANPAGES += ipsec.secrets.5

XMLTO_FLAGS = --searchpath $(abs_srcdir)/d.ipsec.conf:$(abs_srcdir)

# different mode
ipsec.secrets.INSTFLAGS = -m 0600

CONFFILES += ipsec.conf
CONFFILES += ipsec.secrets

LOGROTATEDFILE += libreswan

CONFDSUBDIR = policies
CONFDSUBDIRFILES = clear clear-or-private private-or-clear private block portexcludes.conf

ifndef top_srcdir
include ../mk/dirs.mk
endif
include $(top_srcdir)/mk/config.mk
include $(top_srcdir)/mk/targets.mk
include $(top_srcdir)/mk/rules.mk
include $(top_srcdir)/mk/manpages.mk
include $(top_srcdir)/mk/install.mk

local-base: $(CONFFILES) $(CONFDSUBDIRFILES) $(LOGROTATEDFILE)

local-clean-base:
	rm -f $(foreach file, $(CONFFILES) $(CONFDSUBDIRFILES) $(LOGROTATEDFILE), $(builddir)/$(file))

# For each group of files; first copy to the examples directory and
# then, optionally, install into /etc (but only when
# INSTALL_CONFIGS=true, and only when not already present).

local-install-base: $(CONFFILES) $(CONFDSUBDIRFILES) $(LOGROTATEDFILE)
	@: CONFDDIR - EXAMPLECONFDIR not EXAMPLECONFDDIR and sample suffix
	@set -eu ; $(call install-directory, $(DESTDIR)$(EXAMPLE_IPSEC_SYSCONFDIR))
	@set -eu ; $(call install-file, $(INSTCONFFLAGS) $(ipsec.conf.INSTFLAGS),    $(builddir)/ipsec.conf,    $(DESTDIR)$(EXAMPLE_IPSEC_SYSCONFDIR)/$(notdir $(IPSEC_CONF))-sample)
	@set -eu ; $(call install-file, $(INSTCONFFLAGS) $(ipsec.secrets.INSTFLAGS), $(builddir)/ipsec.secrets, $(DESTDIR)$(EXAMPLE_IPSEC_SYSCONFDIR)/$(notdir $(IPSEC_SECRETS))-sample)
ifeq ($(INSTALL_CONFIGS),true)
	@set -eu ; $(call install-directory, $(DESTDIR)$(IPSEC_CONFDDIR), 0700)
	@set -eu ; $(call install-missing-file, $(INSTCONFFLAGS) $(ipsec.conf.INSTFLAGS),    $(builddir)/ipsec.conf,    $(DESTDIR)$(IPSEC_CONF))
	@set -eu ; $(call install-missing-file, $(INSTCONFFLAGS) $(ipsec.secrets.INSTFLAGS), $(builddir)/ipsec.secrets, $(DESTDIR)$(IPSEC_SECRETS))
endif
	@: CONFDSUBDIR
	@set -eu ; $(call install-directory, $(DESTDIR)$(EXAMPLE_IPSEC_CONFDDIR), 0700)
	@set -eu ; $(call install-directory, $(DESTDIR)$(EXAMPLE_IPSEC_CONFDDIR)/$(CONFDSUBDIR), 0700)
	@set -eu ; $(foreach file, $(CONFDSUBDIRFILES), \
		$(call install-file, $(INSTCONFFLAGS), \
			$(builddir)/$(file), $(DESTDIR)$(EXAMPLE_IPSEC_CONFDDIR)/$(CONFDSUBDIR)/$(file)) ; \
	)
ifeq ($(INSTALL_CONFIGS),true)
	@set -eu ; $(call install-directory, $(DESTDIR)$(IPSEC_CONFDDIR)/$(CONFDSUBDIR), 0700)
	@set -eu ; $(foreach file, $(CONFDSUBDIRFILES), \
		$(call install-missing-file, $(INSTCONFFLAGS), \
			$(DESTDIR)$(EXAMPLE_IPSEC_CONFDDIR)/$(CONFDSUBDIR)/$(file), $(DESTDIR)$(IPSEC_CONFDDIR)/$(CONFDSUBDIR)/$(file)) ; \
	)
endif
	@: LOGROTATED
	@set -eu ; $(call install-directory, $(DESTDIR)$(EXAMPLE_LOGROTATEDDIR))
	@set -eu ; $(call install-file, $(INSTCONFFLAGS), \
		$(builddir)/$(LOGROTATEDFILE), $(DESTDIR)$(EXAMPLE_LOGROTATEDDIR)/$(LOGROTATEDFILE))
ifeq ($(INSTALL_CONFIGS),true)
	@set -eu ; $(call install-directory, $(DESTDIR)$(LOGROTATEDDIR))
	@set -eu ; $(call install-missing-file, $(INSTCONFFLAGS), \
		$(builddir)/$(LOGROTATEDFILE), $(DESTDIR)$(LOGROTATEDDIR)/$(LOGROTATEDFILE))
endif
	@: NSSDIR install
ifeq ($(INSTALL_CONFIGS),true)
	@set -eu ; $(call install-directory, $(DESTDIR)$(NSSDIR), 0700)
endif
ifeq ($(USE_AUTHPAM),true)
	@: PAM
	@set -eu ; $(call install-directory, $(DESTDIR)$(EXAMPLE_PAMCONFDIR))
	@set -eu ; $(call install-file, $(INSTCONFFLAGS), \
			pam.d/pluto, $(DESTDIR)$(EXAMPLE_PAMCONFDIR)/pluto)
 ifeq ($(INSTALL_CONFIGS),true)
	@set -eu ; $(call install-directory, $(DESTDIR)$(PAMCONFDIR))
	@set -eu ; $(call install-missing-file, $(INSTCONFFLAGS), \
			$(DESTDIR)$(EXAMPLE_PAMCONFDIR)/pluto, $(DESTDIR)$(PAMCONFDIR)/pluto)
 endif
endif
	@: $(SELINUX)
ifeq ($(INSTALL_CONFIGS),true)
	@if test -z "$(DESTDIR)" -a -x /usr/sbin/selinuxenabled -a $(DESTDIR)$(SBINDIR) != "$(DESTDIR)/usr/sbin" ; then \
	if /usr/sbin/selinuxenabled ; then  \
		echo -e "\n************************** WARNING ***********************************" ; \
		echo "SElinux is present on this system and the prefix path is not /usr." ; \
		echo "This can cause software failures if selinux is running in Enforcing mode"; \
		echo -e "unless selinux policies are updated manually to allow this.\n" ; \
		echo "The following commands fix a common issue of /usr/local/ being mislabeled"; \
		echo "    sudo restorecon /usr/local/sbin -Rv"; \
		echo "    sudo restorecon /usr/local/libexec/ipsec -Rv"; \
		if test -x /usr/sbin/getenforce ; then \
			echo -e "\nSElinux is currently running in `/usr/sbin/getenforce` mode" ; \
		fi ; \
		echo -e "**********************************************************************\n" ; \
	fi \
	fi
endif

list-local-base:
	@set -eu ; $(foreach file, $(CONFFILES), \
		echo $(DESTDIR)$(SYSCONFDIR)/$(file) ; \
	)
	@set -eu ; $(foreach file, $(CONFFILES), \
		echo $(DESTDIR)$(EXAMPLE_IPSEC_SYSCONFDIR)/$(file)-sample ; \
	)
	@set -eu ; $(foreach file, $(CONFDSUBDIRFILES), \
		echo $(DESTDIR)$(IPSEC_CONFDDIR)/$(CONFDSUBDIR)/$${file} ; \
	)

# Custom rules for ipsec.conf.5; manpages.mk should be updated to
# mimic this behaviour.

$(builddir)/ipsec.conf.5.man: $(srcdir)/ipsec.conf.5.xml $(srcdir)/d.ipsec.conf/*.xml
$(builddir)/ipsec.conf.5.man: $(builddir)/ipsec.conf.5.ok
$(builddir)/ipsec.conf.5.ok:  $(srcdir)/d.ipsec.conf/*.xml
	: do all d.ipsec.conf/*.xml files appear in ipsec.conf.5.xml?
	for x in d.ipsec.conf/*.xml ; do \
		b=$$(basename $${x} .xml) ; \
		if ! grep '"'$${x}'"' ipsec.conf.5.xml > /dev/null ; then \
			echo '"'$${x}'"' missing ; \
			exit 1 ; \
		fi ; \
		if ! grep '&'$${b}';' ipsec.conf.5.xml > /dev/null ; then \
			echo $${b} missing ; \
			exit 1 ; \
		fi ; \
	done
	touch $@

$(top_builddir)/html/ipsec.conf.5.html: $(srcdir)/d.ipsec.conf/*.xml

=== lib/Makefile ===
# Makefile for the interface utilities
#
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# Copyright (C) 2015 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

ifndef top_srcdir
include ../mk/dirs.mk
endif

include $(top_srcdir)/mk/config.mk

SUBDIRS += libswan
SUBDIRS += libwhack
SUBDIRS += libipsecconf
SUBDIRS += liblswtool
ifeq ($(USE_SYSTEMD_WATCHDOG),true)
SUBDIRS += liblswsd
endif

include $(top_srcdir)/mk/targets.mk

=== programs/Makefile ===
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# Copyright (C) 2012 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015,2017,2022 Andrew Cagney
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

ifndef top_srcdir
include ../mk/dirs.mk
endif

include $(top_srcdir)/mk/config.mk

SUBDIRS=

# first
SUBDIRS += pluto
SUBDIRS += whack

SUBDIRS += _import_crl
SUBDIRS += _plutorun
SUBDIRS += _unbound-hook
SUBDIRS += _updown
SUBDIRS += addconn
SUBDIRS += algparse
SUBDIRS += cavp
SUBDIRS += ecdsasigkey
SUBDIRS += ipsec
SUBDIRS += letsencrypt

SUBDIRS += newhostkey
SUBDIRS += readwriteconf
SUBDIRS += rsasigkey
SUBDIRS += setup

SUBDIRS += showhostkey
SUBDIRS += showroute

ifeq ($(USE_XFRM),true)
SUBDIRS +=  _updown.xfrm
endif

ifneq ($(LINUX_VARIANT),)
SUBDIRS += _stackmanager
endif

ifneq ($(BSD_VARIANT),)
SUBDIRS += _updown.bsd
endif

include $(top_srcdir)/mk/targets.mk

=== contrib/look/Makefile ===
# Makefile for miscellaneous programs
# Copyright (C) 2002  Michael Richardson	<mcr@freeswan.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

PROGRAM=look

ifdef top_srcdir
include $(top_srcdir)/mk/program.mk
else
include ../../mk/program.mk
endif

=== initsystems/docker/Makefile ===
ifndef top_srcdir
include ../../mk/dirs.mk
endif

INIT_D_FILE=ipsec.init
SYSCONFIGFILE=$(builddir)/sysconfig.pluto
SYSCONFIGDIR=$(DESTDIR)$(SYSCONFDIR)/sysconfig
SYSVINIT_DEFAULT_START?=

include $(top_srcdir)/mk/config.mk
include $(top_srcdir)/mk/install.mk
include $(top_srcdir)/mk/install.init.d.mk

# Use dependencies to force the order.
#
# (Without this, since local-install-base depends local-base, rules
# like local-base and installinitfiles and checkenabled are allowed to
# run in parallel)

local-base: $(INIT_D_FILE) $(SYSCONFIGFILE)

local-install-base: installsysconfig checkenabled

installsysconfig: local-base
	mkdir -p $(SYSCONFIGDIR)
	if test ! -f $(SYSCONFIGDIR)/pluto ; then \
		$(INSTALL) $(INSTCONFFLAGS) $(SYSCONFIGFILE) $(SYSCONFIGDIR)/pluto ; \
	fi

checkenabled: install.init.d installsysconfig
	@count=0 ; \
	for dir in $(DESTDIR)/etc/rc?.d ; do \
		if test -f $$dir/S??ipsec.init ; then \
			count=1 ; \
		fi ; \
	done ; \
	if test $$count = 0 ; then \
		echo "************************** WARNING ***********************************" ; \
		echo "** The ipsec service is not enabled." ; \
		echo "** Enable it using 'chkconfig ipsec on' or another similar method." ; \
		echo "**********************************************************************" ; \
	fi

include ${top_srcdir}/mk/targets.mk
include ${top_srcdir}/mk/rules.mk

=== initsystems/openrc/Makefile ===
ifndef top_srcdir
include ../../mk/dirs.mk
endif

INIT_D_FILE=ipsec.init

include $(top_srcdir)/mk/config.mk
include $(top_srcdir)/mk/install.mk
include $(top_srcdir)/mk/install.init.d.mk
include ${top_srcdir}/mk/targets.mk
include ${top_srcdir}/mk/rules.mk

=== initsystems/rc.d/Makefile ===
ifndef top_srcdir
include ../../mk/dirs.mk
endif

include $(top_srcdir)/mk/config.mk
include $(top_srcdir)/mk/install.mk

RC_D_FILE = pluto

# XXX: Hack to suppress the man page.  Should one be added?
PROGRAM_MANPAGE=

local-base: $(RC_D_FILE)
local-install-base: $(RC_D_FILE) local-base
	@set -eu ; $(call install-directory, $(DESTDIR)$(EXAMPLE_RC_D_DIR))
	@set -eu ; $(call install-file, $(INSTBINFLAGS), \
		$(builddir)/$(RC_D_FILE), \
		$(DESTDIR)$(EXAMPLE_RC_D_DIR)/$(RC_D_FILE))
ifeq ($(INSTALL_INITSYSTEM),true)
	@set -ue ; $(call install-directory, $(DESTDIR)$(RC_D_DIR))
	@set -eu ; $(call install-missing-file, $(INSTBINFLAGS), \
		$(DESTDIR)$(EXAMPLE_RC_D_DIR)/$(RC_D_FILE), \
		$(DESTDIR)$(RC_D_DIR)/$(RC_D_FILE))
endif
ifeq ($(INSTALL_INITSYSTEM),true)
ifneq ($(BSD_VARIANT),openbsd)
	@. /etc/rc.subr ; \
	load_rc_config pluto ; \
	case " $$rc_directories " in \
	*" $(RC_D_DIR) "* ) ;; \
	* ) \
		echo "" ; \
		echo "" ; \
		echo "    WARNING:" ; \
		echo "" ; \
		echo "        RC_D_DIR=$(RC_D_DIR) is not included in" ; \
		echo "        the /etc/rc.conf variable:" ; \
		echo "" ; \
		echo "            rc_directories=\"$${rc_directories}\"" ; \
		echo "" ; \
		;; \
	esac
endif
endif

list-local-base:
	@set -eu ; echo $(EXAMPLE_RC_D_DIR)/$(RC_D_FILE)
ifeq ($(INSTALL_INITSYSTEM),true)
	@set -eu ; echo $(RC_D_DIR)/$(RC_D_FILE)
endif

include $(top_srcdir)/mk/targets.mk
include $(top_srcdir)/mk/rules.mk

# assumes a single word
pluto: $(BSD_VARIANT).sh $(TRANSFORM_DEPS) | $(builddir)
	$(transform_script)

=== initsystems/sysvinit/Makefile ===
ifndef top_srcdir
include ../../mk/dirs.mk
endif

INIT_D_FILE=ipsec.init
SYSCONFIGFILE=$(builddir)/sysconfig.pluto
SUBDIRS=
SYSCONFIGDIR=$(DESTDIR)$(SYSCONFDIR)/sysconfig
SYSVINIT_DEFAULT_START?=

include $(top_srcdir)/mk/config.mk
include $(top_srcdir)/mk/install.mk
include $(top_srcdir)/mk/install.init.d.mk

# Use dependencies to force the order.
#
# (Without this, since local-install-base depends local-base, rules
# like local-base and installinitfiles and checkenabled are allowed to
# run in parallel)

local-base: $(SYSCONFIGFILE)
local-install-base: installsysconfig checkenabled

installsysconfig: local-base
	mkdir -p $(SYSCONFIGDIR)
	if test ! -f $(SYSCONFIGDIR)/pluto ; then \
		$(INSTALL) $(INSTCONFFLAGS) $(SYSCONFIGFILE) $(SYSCONFIGDIR)/pluto ; \
	fi

checkenabled: install.init.d installsysconfig
	@count=0 ; \
	for dir in $(DESTDIR)/etc/rc?.d ; do \
		if test -f $$dir/S??ipsec.init ; then \
			count=1 ; \
		fi ; \
	done ; \
	if test $$count = 0 ; then \
		echo "************************** WARNING ***********************************" ; \
		echo "** The ipsec service is not enabled." ; \
		echo "** Enable it using 'chkconfig ipsec on' or another similar method." ; \
		echo "**********************************************************************" ; \
	fi

include ${top_srcdir}/mk/targets.mk
include ${top_srcdir}/mk/rules.mk

=== initsystems/upstart/Makefile ===
ifndef top_srcdir
include ../../mk/dirs.mk
endif

LIBRESWANSRCDIR?=$(shell cd ../..; pwd)
SRCDIR?=${LIBRESWANSRCDIR}/initsystems/systemd/

UPSTARTFILE=$(builddir)/ipsec.conf
DEFAULTFILE=$(builddir)/default.pluto
SUBDIRS=
UPSTARTDIR=$(DESTDIR)$(SYSCONFDIR)/init
DEFAULTDIR=$(DESTDIR)$(SYSCONFDIR)/default

include $(top_srcdir)/mk/config.mk

# Use dependencies to force the order.
#
# (Without this, since local-install-base depends local-base, rules
# like local-base and installinitfiles and checkenabled are allowed to
# run in parallel)

local-base: $(UPSTARTFILE) $(DEFAULTFILE)
local-install-base: installupstartconf installdefault

installupstartconf: local-base
	@mkdir -p $(UPSTARTDIR)
	$(INSTALL) $(UPSTARTFILE) $(UPSTARTDIR);

installdefault: local-base
	mkdir -p $(DEFAULTDIR)
	if test ! -f $(DEFAULTDIR)/pluto ; then \
		$(INSTALL) $(DEFAULTFILE) $(DEFAULTDIR)/pluto ; \
	fi

include ${top_srcdir}/mk/targets.mk
include ${top_srcdir}/mk/rules.mk

=== lib/libipsecconf/Makefile ===
# Libreswan library for parsing configuration files
#
# Copyright (C) 2005 Michael Richardson <mcr@xelerance.com> Xelerance Corporation
# Copyright (C) 2012 Paul Wouters <paul@libreswan.org>
# Copyright (C) 2015 Andrew Cagney <cagney@gnu.org>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

LIBRARY=ipsecconf
LIB=lib${LIBRARY}.a

SRCS=confread.c confwrite.c starterwhack.c
SRCS+=parser.tab.c lex.yy.c keywords.c
SRCS+=interfaces.c

OBJS=${SRCS:.c=.o}

ifdef top_srcdir
include ${top_srcdir}/mk/library.mk
else
include ../../mk/library.mk
endif

# Hack to force the generated files to be built first.  Not too bad
# since all the $(OBJS) indirectly depend on the header anyway.
$(OBJS): $(builddir)/parser.tab.h

# Avoid flex bugs:
#
# - flex 3.5.4 (centos 5) doesn't allow a space between the '-o'
#   option and the file name.
#
#   Fortunately later versions of flex seem to handle this.
#
# - flex < 2.5.35 generates an invalid extern
#
#   Use sed to strip this out.
#
# - flex on RHEL 7 generates code that provokes GCC to warn
#   about comparing a signed value with an unsigned value
#   (Combination of a new GCC and an old flex).
#
#   Adding one cast makes RHEL 6's GCC unhappy, so we add two.
#   On RHEL 6, i is int and _yybytes_len is int.
#   On RHEL 7, i is int and _yybytes_len is yy_size_t
#   On Fedora 21, i is yy_size_t and _yybytes_len is yy_size_t
#   On some architectures, yy_size_t is wider than int;
#   which makes a mixed comparison OK.
#
# - flex 2.6.0-11 and gcc 4:5.3.1-3 on debian testing (2016-06-18)
#   also warns about comparisons of different kinds, so we add a third
#   fix.
#
# - avoid sed -i which somehow causes unwritable files on fedora 20
#   with 9p filesystem mount.

LEX = flex

$(builddir)/lex.yy.c: parser.lex
	: no space between -o and scratch output file
	$(LEX) -o$@ --stdout $< | sed \
		-e 's/for ( i = 0; i < _yybytes_len; ++i )$$/for ( i = 0; (yy_size_t)i < (yy_size_t)_yybytes_len; ++i )/' \
		-e '/^extern int isatty.*$$/d' \
		-e 's/if ((int) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {$$/if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {/' \
		> $@.tmp
	: install result
	mv $@.tmp $@

# Use wild card rule so that GNU Make knows that both are output from
# a single recipe.
# - sed command for workaround for older bison vs GCC warning
# - avoid sed -i which somehow causes unwritable files
#   on fedora 20 with 9p filesystem mount
# - avoid creating the target file until it is done
# - $* matches %
#
# - run bison from the builddir so that parser.tab.h defines
#   YY_YY_PARSER_TAB_H_INCLUDED and not a macro containing the
#   buildpath.  See parser-controls.h for why.

ifeq ($(USE_YACC),true)
BISON=yacc -b parser
else
BISON=bison
BISONOSFLAGS=-g --verbose
endif

$(builddir)/%.tab.h $(builddir)/%.tab.c: %.y
	cd $(builddir) && $(BISON) ${BISONOSFLAGS} -v --defines=$*.tab.h -o $*.tab.c.tmp $(abs_srcdir)/$*.y
	sed -e '/^ *#/s/if YYENABLE_NLS/if defined(YYENABLE_NLS) \&\& YYENABLE_NLS/' \
	    -e '/^ *#/s/if YYLTYPE_IS_TRIVIAL/if defined(YYLTYPE_IS_TRIVIAL) \&\& YYLTYPE_IS_TRIVIAL/' \
	    < $(builddir)/$*.tab.c.tmp >  $(builddir)/$*.tab.c.sedtmp
	rm $(builddir)/$*.tab.c.tmp
	mv $(builddir)/$*.tab.c.sedtmp $(builddir)/$*.tab.c

clean: parser-clean
.PHONY: parser-clean
parser-clean:
	cd $(builddir) && rm -f *.tab.[cdho] *.dot *.output lex.yy.[cdho] *tmp

=== lib/liblswsd/Makefile ===
# Libreswan library

# Copyright (C) 2024  Andrew Cagney
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <https://www.gnu.org/licenses/gpl2.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

ifndef top_srcdir
include ../../mk/dirs.mk
endif
include $(top_srcdir)/mk/config.mk

LIB = liblswsd.a

OBJS += lswsd_notify.o
OBJS += lswsd_notifyf.o
OBJS += lswsd_watchdog_enabled.o

include $(top_srcdir)/mk/library.mk

=== debian/changelog ===
libreswan (5.2-2.2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable. (LP: #2119099). Remaining changes:
    - d/tests/control: make opportunistic skippable if builder
      doesn't have access to internet.
    - d/tests/opportunistic: if ping or wget fails then exit 77 to skip
      the test.
  * Dropped Changes:
    - d/tests/control: make cavp skippable if builder
      doesn't have access to internet.
    - d/tests/cavp: if wget fails then exit 77 to skip the test.
  * New Changes:
    - d/p/fix-build-curl-8.14.patch: Fix build of libreswan-5.2 with curl
      8.14.x
    - d/rules: Force ppc64el to build with -O2 to fix FTBFS

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 30 Jul 2025 15:43:47 +0200

libreswan (5.2-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with INITSYSTEM=systemd on linux.
    Make sure binary package content does not change depending on the
    existence of /run/systemd, which is not guaranteed. (Closes: #1073665)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 04 May 2025 22:47:23 +0200

libreswan (5.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add Build-Depends on systemd-dev.
    The package has a Build-Depends on systemd so INITSYSTEM is correctly set
    to systemd during build. But it also needs the systemd.pc pkg-config file
    (provided by systemd-dev) to determine the install paths for the service
    files. So add a corresponding Build-Depends on systemd-dev.
    (Closes: #1073665)

 -- Michael Biebl <biebl@debian.org>  Wed, 19 Mar 2025 11:53:56 +0100

libreswan (5.2-2) unstable; urgency=medium

  * Release to unstable

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 04 Mar 2025 17:28:53 -0500

libreswan (5.2-1) experimental; urgency=medium

  * New upstream release
  * Drop build-dep on libsystemd-dev
  * d/copyright: update
  * Standards-Version: bump to 4.7.1 (no changes needed)
  * Fail building on platforms where AVA is not supported by NSS

  [ Michael Biebl ]
  * Move aliased files from / to /usr (Closes: #1073665)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 26 Feb 2025 19:06:06 -0500

libreswan (4.15-1) unstable; urgency=medium

  * New upstream release
    - Fixes CVE-2024-3652
  * Standards-Version: bump to 4.7.1 (no changes needed)
  * drop patch already applied upstream
  * drop libsystemd-dev from build-deps

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 26 Feb 2025 19:22:24 -0500

libreswan (4.14-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move aliased files from / to /usr (DEP17). (Closes: #1073665)

 -- Michael Biebl <biebl@debian.org>  Sun, 15 Sep 2024 23:08:41 +0200

=== debian/control ===
Source: libreswan
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Uploaders:
 Paul Wouters <paul@libreswan.org>,
 Ondřej Surý <ondrej@debian.org>,
Vcs-Browser: https://salsa.debian.org/debian/libreswan
Vcs-Git: https://salsa.debian.org/debian/libreswan.git
Standards-Version: 4.7.1
Rules-Requires-Root: no
Build-Depends:
 bison,
 bzip2,
 debhelper-compat (= 13),
 flex,
 htmldoc,
 libaudit-dev [linux-any],
 libcap-ng-dev [linux-any],
 libcurl4-gnutls-dev,
 libevent-dev,
 libkrb5-dev,
 libldap2-dev,
 libldns-dev,
 libnspr4-dev,
 libnss3-dev (>= 3.16.1),
 libnss3-tools,
 libpam0g-dev,
 libselinux1-dev [linux-any],
 libunbound-dev (>= 1.6.5~),
 man2html,
 pkgconf,
 po-debconf,
 systemd,
 systemd-dev,
 xmlto,
Homepage: https://libreswan.org/

Package: libreswan
Architecture: any
Pre-Depends:
 debconf | debconf-2.0,
Depends:
 dns-root-data,
 host,
 iproute2 | iproute (>= 20071016),
 iptables,
 libnss3-tools,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 python3,
Provides:
 ike-server,
Conflicts:
 ike-server,
 strongswan-libcharon,
 strongswan-starter,
Replaces:
 ike-server,
Description: Internet Key Exchange daemon
 Libreswan is an IPsec implementation for Linux. It has support for most
 of the extensions (RFC + IETF drafts) related to IPsec, including
 IKEv2, X.509 Digital Certificates, NAT Traversal, and many others.
 .
 Libreswan has been forked from Openswan 2.6.38, which was forked from
 FreeS/WAN 1.99.
 .
 The Libreswan IKE daemon is named pluto. It was inherited from the FreeS/WAN
 project, but provides improved X.509 certificate support and other features.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

# force ppc64el to build with -O2 instead of -O3
# to fix FTBFS
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
  export DEB_CFLAGS_MAINT_APPEND=-O2
endif

# this should track the definition of USERCOMPILE in mk/config.mk:104
# but without -fstack-protector-all for arches that lack stack-protector
ifneq (,$(filter $(DEB_HOST_ARCH), hppa alpha ia64))
export USERCOMPILE = -fno-strict-aliasing -fPIE -DPIE
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ENABLE_SELINUX = USE_LABELED_IPSEC=true USE_LINUX_AUDIT=true
  ENABLE_LIBCAP_NG = USE_LIBCAP_NG=true
  FLAG_INITSYSTEM = INITSYSTEM=systemd
else
  ENABLE_SELINUX = USE_LABELED_IPSEC=false USE_LINUX_AUDIT=false
  ENABLE_LIBCAP_NG = USE_LIBCAP_NG=false
  FLAG_INITSYSTEM =
endif

PKG_CONFIG ?= pkg-config

NSS_CFLAGS := $(shell $(PKG_CONFIG) --cflags nss)
NSS_LDFLAGS := $(shell $(PKG_CONFIG) --libs nss)

CV25519_AVAILABILITY=$(shell if printf '#include <secoidt.h>\nint main() { return SEC_OID_CURVE25519; }' | $(CC) $(NSS_CFLAGS) -x c - -o /dev/null 2> /dev/null; then echo true; else echo false; fi)
NSS_KDF_AVAILABILITY=$(shell if printf '#include <pkcs11t.h>\n#include <pkcs11n.h>\nint main() { return sizeof(CK_NSS_IKE_PRF_DERIVE_PARAMS) > sizeof(CK_NSS_IKE1_APP_B_PRF_DERIVE_PARAMS); }' | $(CC) $(NSS_CFLAGS) -x c - -o /dev/null 2> /dev/null; then echo true; else echo false; fi)
IPSEC_PROFILE_AVAILABILITY=$(shell if printf '#include <certt.h>\nint main() { return certificateUsageIPsec; }' | $(CC) $(NSS_CFLAGS) -x c - -o /dev/null 2> /dev/null; then echo true; else echo false; fi)

DEBIAN_LIBRESWAN_BUILD_FLAGS = \
		ARCH=$(DEB_HOST_ARCH) \
		OBJDIR=OBJ.$(DEB_HOST_ARCH_OS).$(DEB_HOST_ARCH) \
		IPSECVERSION=$(DEB_VERSION_UPSTREAM) \
		PREFIX=/usr \
		USE_LDAP=true \
		USE_LIBCURL=true \
		USE_AUTHPAM=true \
		$(ENABLE_LIBCAP_NG) \
		$(ENABLE_SELINUX) \
		$(FLAG_INITSYSTEM) \
		USE_DH31=$(CV25519_AVAILABILITY) \
		USE_NSS_KDF=$(NSS_KDF_AVAILABILITY) \
		USE_NSS_IPSEC_PROFILE=$(IPSEC_PROFILE_AVAILABILITY) \
		USE_DNSSEC=true \
		DEFAULT_DNSSEC_ROOTKEY_FILE=/usr/share/dns/root.key

override_dh_auto_build:
	dh_auto_build -- programs \
		$(DEBIAN_LIBRESWAN_BUILD_FLAGS)

override_dh_auto_install-arch:
	# Add here commands to install the package into debian/libreswan
	$(MAKE) install \
		$(DEBIAN_LIBRESWAN_BUILD_FLAGS) \
		DESTDIR=$(CURDIR)/debian/libreswan
	find $(CURDIR)/debian/libreswan -iname '*~' -ls -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	debian/tests/cryptocheck
endif

=== debian/tests/control ===
Tests: opportunistic
Restrictions: needs-root, isolation-machine, needs-internet, skippable
Depends:
 dnsutils,
 iputils-ping,
 systemd,
 wget,
 @,

Tests: cryptocheck
Restrictions: allow-stderr
Depends:
 libnss3-tools,
 @,

Tests: cavp
Restrictions: needs-internet, allow-stderr
Depends:
 bzip2,
 ca-certificates,
 diffutils,
 wget,
 @,

=== debian/watch ===
version=4

# look for normal releases:
opts=pgpsigurlmangle=s/$/.asc/ \
 https://download.libreswan.org/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
 
# look for development releases:
## opts=pgpsigurlmangle=s/$/.asc/,uversionmangle=s/(dr|rc)/~\\1/ \
##  https://download.libreswan.org/development/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
